#!/usr/bin/python
# TODO: Make coding more python3-ish
from __future__ import (absolute_import, division)
__metaclass__ = type

from ansible.module_utils.basic import AnsibleModule
from ansible.module_utils.koji import KojiDirective

try:
    import libtaskotron.exceptions as exc
except ImportError:
    libtaskotron_found = False
else:
    libtaskotron_found = True


def main():
    mod = AnsibleModule(
        argument_spec=dict(
            action=dict(required=True),
            arch=dict(required=False, default=['noarch']),
            workdir=dict(required=False, default="/tmp/firstmod"),
            arch_exclude=dict(required=False),
            build_log=dict(required=False, default=False, type="bool"),
            debuginfo=dict(required=False, default=False, type="bool"),
            koji_build=dict(required=False),
            koji_tag=dict(required=False),
            src=dict(required=False, default=False, type="bool"),
            target_dir=dict(required=False, default='.')
        )
    )

    # TODO: check args for completeness
    if not libtaskotron_found:
        mod.fail_json(msg="The libtaskotron python module is required")

    try:
        kojidirective = KojiDirective()
        data = kojidirective.process(mod)
    except exc.TaskotronError, e:
        mod.fail_json(msg=e)

    subjects = ' '.join(data['downloaded_rpms'])

    mod.exit_json(msg="worky!", changed=True, subjects=subjects)

if __name__ == '__main__':
    main()
